#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	protobuf
Version		:	3.19.4
Release		:	17.0.10.rel%{?dist}
Summary		:	Protocol Buffers - Google's data interchange format

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	BSD
URL		:	https://github.com/protocolbuffers/protobuf/tags

Source0		:	%{name}-%{version}.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	autoconf
BuildRequires	:	automake
BuildRequires	:	make
Buildrequires	:	gcc-c++
Buildrequires	:	libtool
Buildrequires	:	zlib-devel

#-----------------------------------------------------------------------------
%description
Protocol Buffers are a way of encoding structured data
in an efficient yet extensible format. Google uses
Protocol Buffers for almost all of its internal RPC
protocols and file formats.
 
Protocol buffers are a flexible, efficient, automated
mechanism for serializing structured data – think XML,
but smaller, faster, and simpler. You define how you want
your data to be structured once, then you can use special
generated source code to easily write and read your
structured data to and from a variety of data streams
and using a variety of languages.
You can even update your data structure without breaking
deployed programs that are compiled against the "old" format.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc CHANGES.txt CONTRIBUTORS.txt README.md
%license LICENSE
%{_libdir}/libprotobuf.so.30*

#=============================================================================
%package		compiler
Summary		:       Protocol Buffers compiler

Requires	:	%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		compiler
This package contains Protocol Buffers compiler for
all programming languages

#-----------------------------------------------------------------------------
%files			compiler
%doc README.md
%license LICENSE
%{_bindir}/protoc
%{_bindir}/protoc
%{_includedir}/google/%{name}/compiler/*.h
%{_includedir}/google/%{name}/compiler/plugin.proto
%{_includedir}/google/%{name}/compiler/cpp/*.h
%{_includedir}/google/%{name}/compiler/csharp/*.h
%{_includedir}/google/%{name}/compiler/java/*.h
%{_includedir}/google/%{name}/compiler/js/*.h
%{_includedir}/google/%{name}/compiler/objectivec/*.h
%{_includedir}/google/%{name}/compiler/php/*.h
%{_includedir}/google/%{name}/compiler/python/*.h
%{_includedir}/google/%{name}/compiler/ruby/*.h
%{_libdir}/libprotoc.so.30*

#=============================================================================
%package		devel
Summary		:       Protocol Buffers C++ headers and libraries

Requires	:	%{name}			= %{version}-%{release}
Requires	:	%{name}-compiler	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
This package contains Protocol Buffers compiler for all
languages and C++ headers and libraries

#-----------------------------------------------------------------------------
%files			devel
%{_includedir}/google/%{name}/*.h
%{_includedir}/google/%{name}/io/*.h
%{_includedir}/google/%{name}/stubs/*.h
%{_includedir}/google/%{name}/util/*.h
%{_includedir}/google/%{name}/generated_message_tctable_impl.inc
%{_includedir}/google/%{name}/port_def.inc
%{_includedir}/google/%{name}/port_undef.inc
%{_includedir}/google/%{name}/*.proto
%{_libdir}/libprotobuf.so
%{_libdir}/libprotoc.so
%{_libdir}/pkgconfig/protobuf.pc

#=============================================================================
%package		lite
Summary		:       Protocol Buffers LITE_RUNTIME libraries

#-----------------------------------------------------------------------------
%description		lite
Protocol Buffers built with optimize_for = LITE_RUNTIME.

#-----------------------------------------------------------------------------
%files			lite
%{_libdir}/libprotobuf-lite.so.30*

#=============================================================================
%package		lite-devel
Summary		:       Protocol Buffers LITE_RUNTIME libraries

Requires	:	%{name}-devel	= %{version}-%{release}
Requires	:	%{name}-lite	= %{version}-%{release}
#-----------------------------------------------------------------------------
%description		lite-devel
Protocol Buffers built with optimize_for = LITE_RUNTIME.

#-----------------------------------------------------------------------------
%files			lite-devel
%{_libdir}/libprotobuf-lite.so
%{_libdir}/pkgconfig/protobuf-lite.pc

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
%build

./autogen.sh
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make} DESTDIR=%{buildroot} install

#To remove libtool library and static library
find 								\
	%{buildroot}%{_libdir}					\
	\(							\
		 -name \*.la					\
		 -o						\
		 -name \*.a					\
	 \)							\
	-delete

#-----------------------------------------------------------------------------
%changelog
